求助:系统不能安装新的软件

系统安装、升级讨论
回复
wjhbh
帖子: 50
注册时间: 2009-01-08 18:53
送出感谢: 1 次
接收感谢: 0

求助:系统不能安装新的软件

#1

帖子 wjhbh » 2011-02-10 11:45

我的系统使用正常,但无论是命令行的 sudo apt-get install还是新立得包管理器都不能再安装新软件包,终端总是提示
Can't exec "local/charmap": 没有该文件或目录 at /usr/share/perl5/Debconf/Encoding.pm line 16.
Use of uninitialized value $Debconf::Encoding::charmap in scalar chomp at /usr/share/perl5/Debconf/Encoding.pm line 17.
dpkg:警告:'ldconfig' not found in PATH or not executable.
dpkg: 1 expected program(s) not found in PATH or not executable.
NB: root's PATH should usually contain /usr/local/sbin, /usr/sbin and /sbin.
E: Sub-process /usr/bin/dpkg returned an error code (2)

不知是哪个部分损坏了?
头像
lainme
论坛版主
帖子: 7805
注册时间: 2008-09-13 19:17
系统: Arch Linux (x86_64)
送出感谢: 3 次
接收感谢: 68 次
联系:

Re: 求助:系统不能安装新的软件

#2

帖子 lainme » 2011-02-10 11:55

代码: 全选

echo $PATH

whereis ldconfig
看下结果
wjhbh
帖子: 50
注册时间: 2009-01-08 18:53
送出感谢: 1 次
接收感谢: 0

Re: 求助:系统不能安装新的软件

#3

帖子 wjhbh » 2011-02-10 12:02

echo $PATH 输出 /home/ubuntu/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
whereis ldconfig 输出 ldconfig: /sbin/ldconfig.real

好像路径都包含啊?
头像
lainme
论坛版主
帖子: 7805
注册时间: 2008-09-13 19:17
系统: Arch Linux (x86_64)
送出感谢: 3 次
接收感谢: 68 次
联系:

Re: 求助:系统不能安装新的软件

#4

帖子 lainme » 2011-02-10 12:14

sudo su

echo $PATH

看下
头像
eexpress
帖子: 58428
注册时间: 2005-08-14 21:55
来自: 长沙
送出感谢: 4 次
接收感谢: 256 次

Re: 求助:系统不能安装新的软件

#5

帖子 eexpress » 2011-02-10 12:40

● dpkg -S /usr/share/perl5/Debconf/Encoding.pm
debconf: /usr/share/perl5/Debconf/Encoding.pm

你系统少安装了debconf。这么重要的包,怎么会少呢。
● 鸣学
wjhbh
帖子: 50
注册时间: 2009-01-08 18:53
送出感谢: 1 次
接收感谢: 0

Re: 求助:系统不能安装新的软件

#6

帖子 wjhbh » 2011-02-10 15:00

sudo su
echo $PATH,输出:
/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

以前系统是正常的,安装包或升级都可以,后来装了不少东西,可能是哪个包没有安装好,破坏了系统结构。
那现在该怎样补救呢,试着安装debconf包,还是上面的提示啊,装不上
头像
lainme
论坛版主
帖子: 7805
注册时间: 2008-09-13 19:17
系统: Arch Linux (x86_64)
送出感谢: 3 次
接收感谢: 68 次
联系:

Re: 求助:系统不能安装新的软件

#7

帖子 lainme » 2011-02-10 15:20

贴一下/usr/share/perl5/Debconf/Encoding.pm这个文件第16、17行,我的是

代码: 全选

$charmap = `locale charmap`;
chomp $charmap;
wjhbh
帖子: 50
注册时间: 2009-01-08 18:53
送出感谢: 1 次
接收感谢: 0

Re: 求助:系统不能安装新的软件

#8

帖子 wjhbh » 2011-02-10 16:13

15if (! $@) {
16 $charmap = `local/charmap`;
17 chomp $charmap;
18 }
头像
lainme
论坛版主
帖子: 7805
注册时间: 2008-09-13 19:17
系统: Arch Linux (x86_64)
送出感谢: 3 次
接收感谢: 68 次
联系:

Re: 求助:系统不能安装新的软件

#9

帖子 lainme » 2011-02-10 16:24

真不明白这个错误是怎么出来的………整个google都没有第二例。

正确的应该是(对于ubuntu 10.04/10.10/11/04)

$charmap = `locale charmap`;

我不知道直接改行不,先改了吧

不过ldconfig也有问题,看起来是没装全还是怎么的。

先把libc-bin包下载下来

代码: 全选

aptitude download libc-bin
然后用归档管理器解压缩下载的包,将里面的sbin/ldconfig和sbin/ldconfig.real复制到/sbin目录下(用root权限复制)

完了后再看看能行不……

不行再执行

代码: 全选

sudo apt-get -f install
sudo dpkg-reconfigure libc6
sudo apt-get install --reinstall libc6
wjhbh
帖子: 50
注册时间: 2009-01-08 18:53
送出感谢: 1 次
接收感谢: 0

Re: 求助:系统不能安装新的软件

#10

帖子 wjhbh » 2011-02-11 9:58

谢谢 lainme 的耐心讲解。
我的系统是9.04的,把$charmap = `locale charmap`;改过后还是不行,按上面方法修复ldconfig也不行,aptitude download libc-bin下载了deb包,解压后data/sbin目录下只有ldconfig,没有ldconfig.real,不知是不是版本的问题。看来问题挺麻烦的,或干脆升级到10.10吧
头像
lainme
论坛版主
帖子: 7805
注册时间: 2008-09-13 19:17
系统: Arch Linux (x86_64)
送出感谢: 3 次
接收感谢: 68 次
联系:

Re: 求助:系统不能安装新的软件

#11

帖子 lainme » 2011-02-11 10:41

额,9.04,那是一个已经有修复的bug。我应该先问版本的 :em06

我贴的方法就是参照9.04的……。

既然有ldconfig,那就先把这个复制过去。如果还是不行,试着更新源再下载。

或者就升级,现在packages.ubuntu.com也没9.04的包了
回复

回到 “系统安装和升级”